<?php
/*
/	CMS Minecraft Shop © ltd VPN BY
/	Форум технической поддержки: http://forums.vpn.by/viewforum.vpn?f=212
/	Адрес информационного сайта: http://cmsminecraftshop.com/
/
*/

if(!defined('IN_VPN')) exit;

vpn_session((empty($sessID) ? false : true), (empty($noCache) ? 0 : $noCache));

//* ---   Start request check   --- */
if((!isset($rcheck) || $rcheck != 1))
{
	if(empty($_SERVER['HTTP_USER_AGENT']) || $_SERVER['HTTP_USER_AGENT'] == '-')
	{
		@header('X-Accel-Expires: 0');
		die('Bad metods!');
	}
	if($_SERVER['REQUEST_METHOD'] == 'TRACE')
	{
		@header('X-Accel-Expires: 0');
		die('Bad metods!');
	}
	if(isset($_REQUEST['GLOBALS']) || isset($_FILES['GLOBALS']))
	{
		@header('X-Accel-Expires: 0');
		die('Bad metods!');
	}
	if(!is_array($GLOBALS))
	{
		@header('X-Accel-Expires: 0');
		die('Bad metods!');
	}
	if(!isset($_REQUEST))
	{
		@header('X-Accel-Expires: 0');
		die('Bad metods!');
	}
}
//* ---   End request check   --- */

function vpn_session_unset()
{
	@header('X-Accel-Expires: 0');

	global $language;

	if(isset($_SESSION['login_count']) && $_SESSION['login_time'])
	{
		$la = $_SESSION['login_count'];
		$lt = $_SESSION['login_time'];

		if(ini_get('session.use_cookies'))
		{
			$params = session_get_cookie_params();
			setcookie(session_name(), '', time() - 42000,
				$params['path'], $params['domain'],
				$params['secure'], $params['httponly']
			);
		}

		@session_destroy();
		//@session_unset();
		$_SESSION['lang'] = $language;
		$_SESSION['login_count'] = $la;
		$_SESSION['login_time'] = $lt;
	}
	else
	{
		if(ini_get('session.use_cookies'))
		{
			$params = session_get_cookie_params();
			setcookie(session_name(), '', time() - 42000,
				$params['path'], $params['domain'],
				$params['secure'], $params['httponly']
			);
		}

		@session_destroy();
		//@session_unset();
		$_SESSION['lang'] = $language;
	}
}

function vpn_session($sid = false, $noCache = 0)
{
	global $mconf, $connect;

	if(isset($_SERVER['REQUEST_URI']) && $_SERVER['REQUEST_URI'] == $mconf['fn'] . '?page=captcha') $noCache = 1;

	if($noCache != 2 && ($noCache == 1 || !empty($_COOKIE[session_name()]) || $_SERVER['REQUEST_METHOD'] == 'POST'))
	{
		@header('X-Accel-Expires: 0');

		if(!defined('DOMAIN'))
		{
			$domain_cookie = explode('.', (empty($_SERVER['HTTP_HOST']) ? '' : clean_url($_SERVER['HTTP_HOST'])));
			$domain_cookie = array_slice($domain_cookie, -2);
			$domain_cookie = '.' . implode ('.', $domain_cookie);
			define('DOMAIN', $domain_cookie);
		}

		$params = session_get_cookie_params();
		$params['domain'] = DOMAIN;

		session_set_cookie_params(15552000, '/', $params['domain'], $params['secure'], true);

		//*
		if(isset($mconf['session']) && $mconf['session'] == 'mysql')
		{
			require_once('./includes/session.php');
			$sess = new session();
			$sess->setDbConnection($connect);

			$sess_handler = session_set_save_handler(
				array($sess, 'open'),
				array($sess, 'close'),
				array($sess, 'read'),
				array($sess, 'write'),
				array($sess, 'destroy'),
				array($sess, 'gc')
			);

			if(!empty($sess_handler) && session_status() !== PHP_SESSION_ACTIVE)
			{
				register_shutdown_function(function(){
					//global $db;

					session_write_close();
					//$db->sql_close();

					if(defined('XHPROF')) file_put_contents(
						XHPROF .
						uniqid() . '.' .
						(isset($_SESSION['id']) ? $_SESSION['id'] : 0) .
						'_CDE' . (isset($_GET['page']) ? '_' . escapeStr($_GET['page']) : '') .
						(isset($_GET['ajax']) ? '_ajax' : '') .
						'.xhprof',
						serialize(xhprof_disable())
					);
				});

				$ss = session_start();
				//var_dump($sess_handler);
				//var_dump($ss);
			}
			else
			{
				session_write_close();
			}
		}
		else
		{
			session_write_close();
		}
		//*/
	}
}

function clean_url($url)
{
	if( $url == '' ) return;

	$url = str_replace( 'http://', '', strtolower( $url ) );
	$url = str_replace( 'https://', '', $url );
	if( substr( $url, 0, 4 ) == 'www.' ) $url = substr( $url, 4 );
	$url = explode( '/', $url );
	$url = reset( $url );
	$url = explode( ':', $url );
	$url = reset( $url );

	return $url;
}

function generate_pagination($base_url, $num_items, $per_page, $start_item, $add_prevnext_text = false, $tpl_prefix = '', $start='start')
{
	global $lang;

	$per_page = ($per_page <= 0) ? 1 : $per_page;

	$seperator = '<span class="page-sep"> </span>';
	$total_pages = ceil($num_items / $per_page);

	if ($total_pages == 1 || !$num_items)
	{
		return '<strong>1</strong>';
	}

	$on_page		= floor($start_item / $per_page) + 1;
	$url_delim		= (strpos($base_url, '?') === false) ? '?' : ((strpos($base_url, '?') === strlen($base_url) - 1) ? '' : '&amp;');

	$page_string	= ($on_page == 1) ? '<strong>1</strong>' : '<a href="' . $base_url . '">1</a>';

	if ($total_pages > 5)
	{
		$start_cnt	= min(max(1, $on_page - 4), $total_pages - 5);
		$end_cnt	= max(min($total_pages, $on_page + 4), 6);

		$page_string .= ($start_cnt > 1) ? '<span class="page-dots"> ... </span>' : $seperator;

		for ($i = $start_cnt + 1; $i < $end_cnt; $i++)
		{
			$page_string .= ($i == $on_page) ? '<strong>' . $i . '</strong>' : '<a href="' . $base_url . $url_delim.$start."=" . (($i - 1) * $per_page) . '">' . $i . '</a>';
			if ($i < $end_cnt - 1)
			{
				$page_string .= $seperator;
			}
		}

		$page_string .= ($end_cnt < $total_pages) ? '<span class="page-dots"> ... </span>' : $seperator;
	}
	else
	{
		$page_string .= $seperator;

		for ($i = 2; $i < $total_pages; $i++)
		{
			$page_string .= ($i == $on_page) ? '<strong>' . $i . '</strong>' : '<a href="' . $base_url . $url_delim.$start."=" . (($i - 1) * $per_page) . '">' . $i . '</a>';
			if ($i < $total_pages)
			{
				$page_string .= $seperator;
			}
		}
	}

	$page_string .= ($on_page == $total_pages) ? '<strong>' . $total_pages . '</strong>' : '<a href="' . $base_url . $url_delim.$start."=" . (($total_pages - 1) * $per_page) . '">' . $total_pages . '</a>';

	if ($add_prevnext_text)
	{
		if ($on_page != 1)
		{
			$page_string = "<a href='$base_url$url_delim$start=" . (($on_page - 2) * $per_page) . "'>{$lang['BACK']}</a>&nbsp;&nbsp;$page_string";
		}

		if ($on_page != $total_pages)
		{
			$page_string .= "&nbsp;&nbsp;<a href='$base_url$url_delim$start=" . ($on_page * $per_page) . "'>{$lang['NEXT']}</a>";
		}
	}

	return $page_string;
}

function LastModified($time, $file = 0)
{
	$time = empty($file) ? filemtime($time) - 10000 : $time;
	$IfModifiedSince = false;
	if(isset($_ENV['HTTP_IF_MODIFIED_SINCE']))		$IfModifiedSince = strtotime(substr($_ENV['HTTP_IF_MODIFIED_SINCE'], 5));
	if(isset($_SERVER['HTTP_IF_MODIFIED_SINCE']))	$IfModifiedSince = strtotime(substr($_SERVER['HTTP_IF_MODIFIED_SINCE'], 5));

	if(!empty($IfModifiedSince) && $IfModifiedSince >= $time)
	{
		@header($_SERVER['SERVER_PROTOCOL'] . ' 304 Not Modified');
		exit;
	}

	@header('Last-Modified: '. gmdate('D, d M Y H:i:s \G\M\T', $time));
	return;
}

function buyid()
{
	global $connect;

	$sell_q	= mysql_query('SELECT value FROM ' . SETTINGS . ' WHERE name="sell_off"', $connect) or die('Error MySQL query ' . mysql_error());
    $sell	= mysql_result($sell_q, 0);
	$sell	= explode(',', $sell);
	$time	= date('N', time());
	$sell	= empty($sell[$time]) ? 0 : $sell[$time];

	return	$sell;
}

function monitoring()
{
	global $mconf, $server, $THEME, $lang;

	$monitoring = '';

	if(empty($mconf['ctime']) || ($mconf['ctime'] > 0 && file_exists($mconf['cfile']) && (filemtime($mconf['cfile']) + $mconf['ctime'] >= time())))
	{
		$monitoring	= file_get_contents($mconf['cfile']);
	}
	else 
	{
		if($mconf['type'] == 'rust')
		{
			require_once('./includes/query.rust.php');
			$q = new RustQuery($mconf['host'], $mconf['port']);

			if(($r = $q->GetInfo()) != false)
			{
				$info = $server	= array(
					'0' => $mconf['host'],
					'1' => $r['name'],
					'2' => $r['Software'],
					'3' => $r['Players'],
					'4' => $r['MaxPlayers'],
				);
				$monitoring = '';
			}
			else $info = 'OFF:';
		}
		else
		{
			$rcon = new MinecraftRcon;
			$rcon->Connect($mconf['host'], $mconf['rport'], $mconf['rcon']);
			$info = $server	= $rcon->Command();

			if($info != 'OFF:') $monitoring = $rcon->Command('list');
		}

		if($info == 'OFF:')
		{
			$monitoring	= '
			<div class="menu-block"><div class="server-status">
				<h5><img src="' . $THEME . 'images/chart-bar_sticker.png" width="25" height="25" alt=""/>' . $mconf['name'] . '</h5>
				<div class="serveroff" style="background-position:-200px 0;">Error</div>
				<p class="tiny-text">' . $lang['ADRESS'] . ': ' . $mconf['host'] . ':' . $mconf['port'] . '</p>
			</div></div>';
		}
		else $monitoring = GetUserListHTML($monitoring);

		if($mconf['ctime'] > 0)
		{
			if(!@file_put_contents($mconf['cfile'], $monitoring))
			{
				echo "\n <br /><font color=red>Unable to write to file: {$mconf['cfile']}</font>";
			}
		}
	}

	global $connect;

	$q = mysql_query('
		SELECT
			`name`, `itemid`, `price`
		FROM
			`' . DONATE_SHOP . '`
		WHERE
			`itemid` = "' . buyid() . '"
	', $connect) or die('Error MySQL query ' . mysql_error());

	$item = mysql_fetch_array($q);

	if(isset($item) && is_array($item) && sizeof($item) > 0)
	{
		$item['p'] = floatval($item['price']) / 2;

		$item['img'] = empty($item['itemid']) ? '' : str_replace(':', '.', $item['itemid']);
		$item['name'] = empty($item['name']) ? '' : strip_tags($item['name']);

		$monitoring	.= empty($item['name']) ? '' : '
		<div class="menu-block">		
			<img src="' . $THEME . 'images/buy.png" width="25" height="25" alt="" />
			<h4>' . $lang['TENDER'] . ':</h4>
			<div class="buy-now">
				<img src="' . $mconf['items'] . '' . $item['img'] . '.png" width="150" height="150" title="" alt="' . $item['name'] . '" />
				<br clear="all" />
				<h5>' . $item['name'] . '</h5>
				<h5><s>' . $item['price'] . '</s> <font color="red">' . $item['p'] . ' ' . $lang['MS_MINERS'] . '!</font></h5><br>
				<center><a href="./?page=shop&id=' . $item['itemid'] . '" class="button-defolt">' . $lang['BUY_NOW'] . '</a></center>
				<p>' . $lang['ACTION_WORCKS'] . '</p>
			</div>
		</div>';
	}

	return $monitoring;
}

function menu()
{
	global $mconf, $connect, $adminuser, $lang, $coins;

	if(empty($_SESSION['playername'])) $coins = 0;
	else
	{
		$q		= mysql_query("SELECT balance FROM " . MONEY . " WHERE username='".$_SESSION['playername']."';",$connect) or die('Error MySQL query ' . mysql_error());
		$coins	= @mysql_result($q,0);
		$coins	= empty($coins) ? 0 : $coins ;
	}

	if(isset($_SESSION['playername']))
	{
		$pageadm = is_array($adminuser) && in_array($_SESSION['playername'], $adminuser) ? '
						<a href="admin.php">' . $lang['SETTINGS'] . '</a>
						<ul class="subnav">
							<li><a href="admin.php?page=smtp"><i class="icon-envelope"></i> ' . $lang['S_MAIL'] . '</a></li>
							<li><a href="admin.php?page=groups"><i class="icon-gift"></i> ' . $lang['GROUPS'] . '</a></li>
							<li><a href="admin.php?page=realmoney"><i class="icon-briefcase"></i> ' . $lang['MONEY'] . '</a></li>
							<li><a href="admin.php?page=money"><i class="icon-leaf"></i> ' . $lang['MINERS'] . '</a></li>
							<li><a href="admin.php?page=salle"><i class="icon-plus"></i> ' . $lang['PRODUCT_ADD'] . '</a></li>
							<li><a href="admin.php?page=rcon"><i class="icon-wrench"></i> ' . $lang['RCON'] . '</a></li>
							<li><a href="admin.php?page=logs-buy"><i class="icon-tasks"></i> ' . $lang['LOG_SHOP'] . '</a></li>
							<li><a href="admin.php?page=db"><i class="icon-hdd"></i> ' . $lang['DATABASE'] . '</a></li>
						</ul>' : '<a href="./?page=qstart">' . $lang['START'] . '</a>';
		$menu	= '
		<div class="default" id="menu"><div class="menu-position">
		﻿	<div class="container">
				<ul class="topnav">
					<li><a href="./">' . $lang['HOME'] . '</a></li>
					<li>' . $pageadm . '</li>
					<li>
						<a href="./?page=shop-info">' . $lang['SHOP'] . '</a>
						<ul class="subnav">
							<li><a href="./?page=money-inf"><i class="icon-thumbs-up"></i> ' . $lang['ADD_MONEY'] . '</a></li>
							<li><a href="./?page=shop&id=10000"><i class="icon-retweet"></i> ' . $lang['CHANGE_MONEY'] . '</a></li>
							<li><a href="./?page=shop"><i class="icon-th-large"></i> ' . $lang['ADMIN_SHOP'] . '</a></li>
							<li><a href="./?page=shop&mode=basket"><i class="icon-shopping-cart"></i> ' . $lang['TRASH'] . '</a></li>
							<li><a href="./?page=groups"><i class="icon-gift"></i> ' . $lang['BUY_PERMISSION'] . '</a></li>
							<li><a href="./?page=skins"><i class="icon-picture"></i> ' . $lang['CHANGE_SKIN'] . '</a></li>
							<li><a href="./?page=moneystats"><i class="icon-certificate"></i> ' . $lang['TOP_MINERS'] . '</a></li>
						</ul>
					</li>
					<li><a href="./?page=bans">' . $lang['BANLIST'] . '</a></li>
					' . (empty($mconf['surl']) ? '' : '<li><a href="' . $mconf['surl'] . '">' . $lang['SITE'] . '</a></li>') . '
					' . (empty($mconf['furl']) ? '' : '<li><a href="' . $mconf['furl'] . '">' . $lang['FORUM'] . '</a></li>') . '
				</ul>
			</div>

			<div id="menu-user-panel">
				<table>
					<tr>
						<td>' . $lang['HELLO'] . ', ' . $_SESSION['playername'] . '. ' . $lang['YOU_HAVE'] . ' ' . $coins . ' ' . $lang['MS_MINERS'] . '.</td>
					</tr>
					<tr>
						<td>
							<a href="' . $mconf['ucp'] . '">' . $lang['UCP'] . '</a>
							' . (empty($mconf['upm']) ? '' : '| <a href="' . $mconf['upm'] . '">' . $lang['MESSAGES'] . '</a>') . '
							' . (empty($mconf['uprl']) ? (empty($mconf['prof']) ? '' : '| <a href="' . $mconf['prof'] . $_SESSION['playername'] . '">' . $lang['PROFILE'] . '</a>') : '| <a href="' . $mconf['uprl'] . $_SESSION['playername'] . '">' . $lang['PROFILE'] . '</a>') . '
						</td>
					</tr>
				</table>
				<a href="./?page=logoff" class="panel-submit" style="float:right; margin-right:10px;">Выйти</a>
			</div>
		</div></div>';
	}
	else
	{
		global $uau;

		if(!empty($mconf['usl']) && ($uau['cms'] == 'ms_md5' || $uau['cms'] == 'authme'))
		{
			$ulogin = '
			<div style="float:left;width:180px;background:none;margin:2px 0 0 0;">
				<script src="//ulogin.ru/js/ulogin.js"></script>
				<div id="uLogin" data-ulogin="display=small;fields=first_name,last_name;providers=webmoney,vkontakte,yandex,odnoklassniki,mailru,twitter,facebook;hidden=other;redirect_uri=' . urlencode('http://' . $_SERVER['HTTP_HOST'] . $mconf['fn'] . '?page=ulogin') . '"></div>
				<a href="' . $mconf['reg'] . '">' . $lang['REGISTER'] . '</a>
				<a href="' . $mconf['spsw'] . '">' . $lang['FORGOT_PASS'] . '</a>
			</div>
			';
		}
		else
		{
			$ulogin = '
			<table style="float:left;margin-left:40px;">
				<tr><td><a href="' . $mconf['reg'] . '">' . $lang['REGISTER'] . '</a></td></tr>
				<tr><td><a href="' . $mconf['spsw'] . '">' . $lang['FORGOT_PASS'] . '</a></td></tr>
			</table>
			';
		}

		$menu	= '
		<div class="default" id="menu"><div class="menu-position">
		﻿	<div class="container">
				<ul class="topnav">
					<li><a href="./">' . $lang['HOME'] . '</a></li>
					<li><a href="./?page=qstart">' . $lang['START'] . '</a></li>
					<li>
						<a href="./?page=shop-info">' . $lang['SHOP'] . '</a>
						<ul class="subnav">
							<li><a href="./?page=money-inf"><i class="icon-thumbs-up"></i> ' . $lang['ADD_MONEY'] . '</a></li>
							<li><a href="./?page=shop&id=10000"><i class="icon-retweet"></i> ' . $lang['CHANGE_MONEY'] . '</a></li>
							<li><a href="./?page=shop"><i class="icon-th-large"></i> ' . $lang['ADMIN_SHOP'] . '</a></li>
							<li><a href="./?page=groups"><i class="icon-gift"></i> ' . $lang['BUY_PERMISSION'] . '</a></li>
							<li><a href="./?page=skins"><i class="icon-picture"></i> ' . $lang['CHANGE_SKIN'] . '</a></li>
							<li><a href="./?page=moneystats"><i class="icon-certificate"></i> ' . $lang['TOP_MINERS'] . '</a></li>
						</ul>
					</li>
					<li><a href="./?page=bans">' . $lang['BANLIST'] . '</a></li>
					' . (empty($mconf['surl']) ? '' : '<li><a href="' . $mconf['surl'] . '">' . $lang['SITE'] . '</a></li>') . '
					' . (empty($mconf['furl']) ? '' : '<li><a href="' . $mconf['furl'] . '">' . $lang['FORUM'] . '</a></li>') . '
				</ul>
			</div>

			<div id="menu-user-panel">
				<form action="./?page=login" method="post" enctype="multipart/form-data">
					<table>
						<tr>
							<td>' . $lang['LOGIN'] . ':</td>
							<td><input required type="text" name="username" id="panel-login"/></td>
						</tr>
						<tr>
							<td>' . $lang['PASSWORD'] . ':</td>
							<td><input required type="password" name="password" id="panel-password"/></td>
						</tr>
					</table>
					<input type="submit" value="' . $lang['ENTER'] . '" class="panel-submit" style="margin:4px 7px 0 7px;" />
					' . $ulogin . '
				</form>
			</div>
		</div></div>';
	}

	return $menu;
}

function login()
{
	global $salt, $uau, $mconf, $lang;
	$err = array();

	if(isset($_SESSION['login_count']) && isset($_SESSION['login_time']))
	{
		if(time() > $_SESSION['login_time'] + 1800)
		{
			$_SESSION['login_count'] = 0;
		}
	}

	if(empty($_REQUEST['username']) || empty($_REQUEST['password']))
	{
		$err[] = $lang['ERROR_FIELDS'];
	}
	elseif(isset($_SESSION['login_count']) && isset($_SESSION['login_time']) && $_SESSION['login_count'] >= 5 && time() < $_SESSION['login_time'] + 1800)
	{
		$err[] = $lang['LOGIN_ATTEMPT'];
		header('Status: 403');
	}
	elseif((!preg_match('#^[A-Za-z0-9_\-]+$#i', @$_REQUEST['username'])) || (!preg_match('#^[A-Za-z0-9]+$#i', @$_REQUEST['password'])))
	{
		$err[] = $lang['ERROR_CHAR'];
		header('Status: 403');
	}
	else
	{
		$_REQUEST['username'] = isset($_REQUEST['username']) ? mysql_real_escape_string($_REQUEST['username']) : '';
		$_REQUEST['password'] = isset($_REQUEST['password']) ? mysql_real_escape_string($_REQUEST['password']) : '';
		$_REQUEST['rememberMe'] = isset($_REQUEST['rememberMe']) ? (int)$_REQUEST['rememberMe'] : 0;

		$auth = mysql_connect($uau['host'], $uau['user'], $uau['pass'], true) or die("Access Denied!");
		mysql_select_db($uau['db'], $auth); mysql_query('SET names UTF8', $auth);

		if($uau['cms'] == 'XENFORO')
		{
			if(!empty($uau['path']))
			{
				$startTime = microtime(true);
				require_once($uau['path'] . '/library/XenForo/Autoloader.php');
				XenForo_Autoloader::getInstance()->setupAutoloader($uau['path'] . '/library');
				XenForo_Application::initialize($uau['path'] . '/library', $uau['path']);
				XenForo_Application::set('page_start_time', $startTime);
				$db = XenForo_Application::get('db');

				if(isset($_REQUEST['username']) && isset($_REQUEST['password']))
				{
					$user = $_REQUEST['username'];
					$pwd = $_REQUEST['password'];

					$res = $db->fetchCol('select user_id from xf_user where username=' . $db->quote($user));

					if(!empty($res['0']) && $user_id = $res['0'])
					{
						if(class_exists('XenForo_Authentication_Core12')) $auth = new XenForo_Authentication_Core12;
						elseif(class_exists('XenForo_Authentication_Core')) $auth = new XenForo_Authentication_Core;

						$sql = 'select data from xf_user_authenticate where `user_id` = ' . $user_id;
						$res = $db->fetchCol($sql);

						$auth->setData($res['0']);
						$is_valid = $auth->authenticate($user_id, $pwd);

						if($is_valid)
						{
							$user = $db->fetchCol('select username from xf_user where username=' . $db->quote($user));
							$_SESSION['playername']	= $user[0];
							$_SESSION['id']			= $user_id;
							$_SESSION['pm']			= 0;
							$_SESSION['rememberMe']	= $_REQUEST['rememberMe'];
						}
						else
						{
							$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
							$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
							$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
						}
					}
					else
					{
						$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
						$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
						$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
					}
				}
				else
				{
					$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
					$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
					$err[] = '<p>' . $lang['ERROR_PASS'] . ' 1 <br /></p>';
				}
			}
			else
			{
				function hash_xenforo($pass, $salt)
				{
					$cryptPass = false;
					$cryptPass = hash('sha256', hash('sha256', $pass) . $salt);
					return $cryptPass;
				}

				$q	= mysql_query('
						SELECT ' . $uau['table'] . '.' . $uau['id'] . ',' .
								$uau['table'] . '.' . $uau['cuser'] . ',' .
								$uau['salt'] . '.' . $uau['id'] . ',' .
								$uau['salt'] . '.' . $uau['cpass'] . (empty($uau['pm']) ? '' : ', ' . $uau['table'] . '.' . $uau['pm']) . '
						FROM ' . $uau['table'] . ', ' . $uau['salt'] . '
						WHERE ' . $uau['table'] . '.' . $uau['id'] . ' = ' . $uau['salt'] . '.' . $uau['id'] . '
						AND ' . $uau['table'] . '.' . $uau['cuser'] . '="' . $_REQUEST['username'] . '"') or die('73296 ' . mysql_error($amc));
				$r	= mysql_fetch_assoc($q);

				if($real = substr($r[$uau['cpass']],22,64))
				{
					$salt	= substr($r[$uau['cpass']],105,64);
					$check	= hash_xenforo($_REQUEST['password'], $salt);
					if(strcasecmp($real, $check) == 0)
					{
						$_SESSION['playername']	= $r[$uau['cuser']];
						$_SESSION['id']			= $r[$uau['id']];
						$_SESSION['pm']			= $r[$uau['pm']];
						$_SESSION['rememberMe']	= $_REQUEST['rememberMe'];
					}
					else
					{
						$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
						$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
						$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
					}
				}
				else
				{
					$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
					$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
					$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
				}
			}
		}
		elseif($uau['cms'] == 'IPB')
		{
			$q = mysql_query('
				SELECT '.$uau['id'].', '.$uau['cuser'].', '.$uau['cpass'].', ' . $uau['salt'] . ', ' . $uau['pm'] . '
				FROM ' . $uau['table'] . '
				WHERE ' . $uau['cuser'] . '="' . $_REQUEST['username'] . '"
			', $auth) or die('73324621 ' . mysql_error($auth));
			$r = mysql_fetch_assoc($q);
			if($r[$uau['cpass']])
			{
				$check	= md5(md5($r[$uau['salt']]).md5($_REQUEST['password']));

				if(strcasecmp($r[$uau['cpass']], $check) == 0)
				{
					$_SESSION['playername']	= $_REQUEST['username'];
					$_SESSION['id']			= $r[$uau['id']];
					$_SESSION['pm']			= $r[$uau['pm']];
					$_SESSION['rememberMe']	= $_REQUEST['rememberMe'];
					@setcookie('Remember', $_REQUEST['rememberMe']);
				}
				else
				{
					$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
					$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
					$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
				}
			}
			else
			{
				$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
				$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
				$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
			}
		}
		elseif($uau['cms'] == 'VBULETIN')
		{
			$r = mysql_fetch_assoc(mysql_query('
				SELECT ' . $uau['id'] . ', ' .
					$uau['cuser'] . ', ' .
					$uau['cpass'] . ', ' .
					$uau['salt'] . ', ' .
					$uau['pm'] . '
				FROM ' . $uau['table'] . '
				WHERE ' . $uau['cuser'] . '="' . $_REQUEST['username'] . '"')
				);
			if($r[$uau['cpass']])
			{
				$check	= md5(md5($_REQUEST['password']) . $r[$uau['salt']]);

				if(strcasecmp($r[$uau['cpass']], $check) == 0)
				{
					$_SESSION['playername']	= $_REQUEST['username'];
					$_SESSION['id']			= $r[$uau['id']];
					$_SESSION['pm']			= $r[$uau['pm']];
					$_SESSION['rememberMe']	= $_REQUEST['rememberMe'];
					@setcookie('Remember', $_REQUEST['rememberMe']);
				}
				else
				{
					$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
					$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
					$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
				}
			}
			else
			{
				$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
				$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
				$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
			}
		}
		elseif($uau['cms'] == 'phpBB3')
		{
			$q	= mysql_query('
						SELECT `'.$uau['id'].'`, `'.$uau['cuser'].'`, `'.$uau['cpass'].'`, `'.$uau['pm'].'`
						FROM `'.$uau['table'].'`
						WHERE `'.$uau['cuser'].'` = "'.$_REQUEST['username'].'"
				', $auth) or die('5125 ' . mysql_error($auth));
			$r = mysql_fetch_assoc($q);
			if($r[$uau['cpass']])
			{
				class PasswordHash
				{
				   var $itoa64;
				   var $iteration_count_log2;
				   var $portable_hashes;
				   var $random_state;

				   function PasswordHash($iteration_count_log2, $portable_hashes)
				   {
					  $this->itoa64 = './0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';

					  if ($iteration_count_log2 < 4 || $iteration_count_log2 > 31)
						 $iteration_count_log2 = 8;
					  $this->iteration_count_log2 = $iteration_count_log2;

					  $this->portable_hashes = $portable_hashes;

					  $this->random_state = microtime() . getmypid();
				   }

				   function get_random_bytes($count)
				   {
					  $output = '';
					  if (($fh = @fopen('/dev/urandom', 'rb'))) {
						 $output = fread($fh, $count);
						 fclose($fh);
					  }

					  if (strlen($output) < $count) {
						 $output = '';
						 for ($i = 0; $i < $count; $i += 16) {
							$this->random_state =
								md5(microtime() . $this->random_state);
							$output .=
								pack('H*', md5($this->random_state));
						 }
						 $output = substr($output, 0, $count);
					  }

					  return $output;
				   }

				   function encode64($input, $count)
				   {
					  $output = '';
					  $i = 0;
					  do {
						 $value = ord($input[$i++]);
						 $output .= $this->itoa64[$value & 0x3f];
						 if ($i < $count)
							$value |= ord($input[$i]) << 8;
						 $output .= $this->itoa64[($value >> 6) & 0x3f];
						 if ($i++ >= $count)
							break;
						 if ($i < $count)
							$value |= ord($input[$i]) << 16;
						 $output .= $this->itoa64[($value >> 12) & 0x3f];
						 if ($i++ >= $count)
							break;
						 $output .= $this->itoa64[($value >> 18) & 0x3f];
					  } while ($i < $count);

					  return $output;
				   }

				   function gensalt_private($input)
				   {
					  $output = '$H$';
					  $output .= $this->itoa64[min($this->iteration_count_log2 +
						 ((PHP_VERSION >= '5') ? 5 : 3), 30)];
					  $output .= $this->encode64($input, 6);

					  return $output;
				   }

				   function crypt_private($password, $setting)
				   {
					  $output = '*0';
					  if (substr($setting, 0, 2) == $output)
						 $output = '*1';

					  if (substr($setting, 0, 3) != '$H$')
						 return $output;

					  $count_log2 = strpos($this->itoa64, $setting[3]);
					  if ($count_log2 < 7 || $count_log2 > 30)
						 return $output;

					  $count = 1 << $count_log2;

					  $salt = substr($setting, 4, 8);
					  if (strlen($salt) != 8)
						 return $output;

					  if (PHP_VERSION >= '5') {
						 $hash = md5($salt . $password, TRUE);
						 do {
							$hash = md5($hash . $password, TRUE);
						 } while (--$count);
					  } else {
						 $hash = pack('H*', md5($salt . $password));
						 do {
							$hash = pack('H*', md5($hash . $password));
						 } while (--$count);
					  }

					  $output = substr($setting, 0, 12);
					  $output .= $this->encode64($hash, 16);

					  return $output;
				   }

				   function gensalt_extended($input)
				   {
					  $count_log2 = min($this->iteration_count_log2 + 8, 24);
					  $count = (1 << $count_log2) - 1;

					  $output = '_';
					  $output .= $this->itoa64[$count & 0x3f];
					  $output .= $this->itoa64[($count >> 6) & 0x3f];
					  $output .= $this->itoa64[($count >> 12) & 0x3f];
					  $output .= $this->itoa64[($count >> 18) & 0x3f];

					  $output .= $this->encode64($input, 3);

					  return $output;
				   }

				   function gensalt_blowfish($input)
				   {
					  $itoa64 = './0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';

					  $output = '$2a$';
					  $output .= chr(ord('0') + $this->iteration_count_log2 / 10);
					  $output .= chr(ord('0') + $this->iteration_count_log2 % 10);
					  $output .= '$';

					  $i = 0;
					  do {
						 $c1 = ord($input[$i++]);
						 $output .= $itoa64[$c1 >> 2];
						 $c1 = ($c1 & 0x03) << 4;
						 if ($i >= 16) {
							$output .= $itoa64[$c1];
							break;
						 }

						 $c2 = ord($input[$i++]);
						 $c1 |= $c2 >> 4;
						 $output .= $itoa64[$c1];
						 $c1 = ($c2 & 0x0f) << 2;

						 $c2 = ord($input[$i++]);
						 $c1 |= $c2 >> 6;
						 $output .= $itoa64[$c1];
						 $output .= $itoa64[$c2 & 0x3f];
					  } while (1);

					  return $output;
				   }

				   function HashPassword($password)
				   {
					  $random = '';

					  if (CRYPT_BLOWFISH == 1 && !$this->portable_hashes) {
						 $random = $this->get_random_bytes(16);
						 $hash =
							 crypt($password, $this->gensalt_blowfish($random));
						 if (strlen($hash) == 60)
							return $hash;
					  }

					  if (CRYPT_EXT_DES == 1 && !$this->portable_hashes) {
						 if (strlen($random) < 3)
							$random = $this->get_random_bytes(3);
						 $hash =
							 crypt($password, $this->gensalt_extended($random));
						 if (strlen($hash) == 20)
							return $hash;
					  }

					  if (strlen($random) < 6)
						 $random = $this->get_random_bytes(6);
					  $hash =
						  $this->crypt_private($password,
						  $this->gensalt_private($random));
					  if (strlen($hash) == 34)
						 return $hash;

					  return '*';
				   }

				   function CheckPassword($password, $stored_hash)
				   {
					  $hash = $this->crypt_private($password, $stored_hash);
					  if ($hash[0] == '*')
						 $hash = crypt($password, $stored_hash);

					  return $hash == $stored_hash;
				   }
				}

				$t_hasher = new PasswordHash(8, TRUE);

				if($t_hasher->CheckPassword($_REQUEST['password'], $r[$uau['cpass']]))
				{
					$_SESSION['playername']	= $_REQUEST['username'];
					$_SESSION['id']			= $r[$uau['id']];
					$_SESSION['pm']			= $r[$uau['pm']];
					$_SESSION['rememberMe']	= $_REQUEST['rememberMe'];
					@setcookie('Remember', $_REQUEST['rememberMe']);
				}
				else
				{
					$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
					$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
					$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
				}
			}
			else
			{
				$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
				$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
				$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
			}
		}
		elseif($uau['cms'] == 'joomla')
		{
			$r = mysql_fetch_assoc(mysql_query('
					SELECT ' . $uau['id'] . ', ' . $uau['cuser'] . ', ' . $uau['cpass'] . '
					FROM ' . $uau['table'] . '
					WHERE ' . $uau['cuser'] . '="' . $_REQUEST['username'] . '"'));
			if($r[$uau['cpass']])
			{
				$salt	= explode( ':', $r[$uau['cpass']]);
				$check = md5($_REQUEST['password'] . $salt['1']) . ':' . $salt['1'];

				if(strcasecmp($r[$uau['cpass']], $check) === 0)
				{
					$_SESSION['playername']	= $_REQUEST['username'];
					$_SESSION['id']			= $r[$uau['id']];
					$_SESSION['pm']			= '0';
					$_SESSION['rememberMe']	= $_REQUEST['rememberMe'];
					@setcookie('Remember', $_REQUEST['rememberMe']);
				}
				else
				{
					$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
					$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
					$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
				}
			}
			else
			{
				$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
				$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
				$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
			}
		}
		elseif($uau['cms'] == 'authme')
		{
			$r = mysql_fetch_assoc(mysql_query('
					SELECT ' . $uau['id'] . ', ' . $uau['cuser'] . ', ' . $uau['cpass'] . '
					FROM ' . $uau['table'] . '
					WHERE ' . $uau['cuser'] . '="' . $_REQUEST['username'] . '"')
				);
			if($r[$uau['cpass']])
			{
				$sha_info = explode("$", $r[$uau['cpass']]);
				if($sha_info[1] === "SHA")
				{
					$salt				= $sha_info[2];
					$sha256_password	= hash('sha256', $_REQUEST['password']);
					$sha256_password	.= $sha_info[2];

					if(strcasecmp(trim($sha_info[3]), hash('sha256', $sha256_password)) == 0)
					{
						$_SESSION['playername']	= $_REQUEST['username'];
						$_SESSION['id']			= $r[$uau['id']];
						$_SESSION['pm']			= 0;
						$_SESSION['rememberMe']	= $_REQUEST['rememberMe'];
						@setcookie('Remember', $_REQUEST['rememberMe']);
					}
					else
					{
						$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
						$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
						$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
					}
				}
			}
			else
			{
				$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
				$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
				$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
			}
		}
		elseif($uau['cms'] == 'DLE')
		{
			$q	= mysql_query("
					SELECT " . $uau['id'] . ", " . $uau['cuser'] . ", " . $uau['cpass'] . (empty($uau['pm']) ? '' : ', ' . $uau['pm']) . "
					FROM " . $uau['table'] . "
					WHERE " . $uau['cuser'] . "='" . $_REQUEST['username'] . "'", $auth) or die('7154 ' . mysql_error($auth));
			$r = mysql_fetch_assoc($q);

			if($r[$uau['cpass']])
			{
				if(strcasecmp($r[$uau['cpass']], md5(md5($_REQUEST['password']))) === 0)
				{
					$_SESSION['playername']	= $_REQUEST['username'];
					$_SESSION['id']			= $r[$uau['id']];
					$_SESSION['pm']			= $r[$uau['pm']];
					$_SESSION['rememberMe']	= $_REQUEST['rememberMe'];
					@setcookie('Remember', $_REQUEST['rememberMe']);
				}
				else
				{
					$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
					$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
					$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
				}
			}
			else
			{
				$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
				$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
				$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
			}
		}
		elseif($uau['cms'] == 'WORDPRESS')
		{
			function hash_wordpress($real = '', $post = '')
			{
				$cryptPass = false;
				$itoa64 = './0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
				$count_log2 = strpos($itoa64, $real[3]);
				$count = 1 << $count_log2;
				$salt = substr($real, 4, 8);
				$input = md5($salt . $post, TRUE);
				do $input = md5($input . $post, TRUE);
				while (--$count);        
				$output = substr($real, 0, 12);
				$count = 16; $i = 0;
				do 
				{
					$value = ord($input[$i++]);
					$cryptPass .= $itoa64[$value & 0x3f];
					if ($i < $count) $value |= ord($input[$i]) << 8;
					$cryptPass .= $itoa64[($value >> 6) & 0x3f];
					if ($i++ >= $count) break;
					if ($i < $count) $value |= ord($input[$i]) << 16;
					$cryptPass .= $itoa64[($value >> 12) & 0x3f];
					if ($i++ >= $count) break;
					$cryptPass .= $itoa64[($value >> 18) & 0x3f];
				}
				while($i < $count);

				$cryptPass = $output . $cryptPass;
				return $cryptPass;
			}

			$q	= mysql_query('
					SELECT ' . $uau['id'] . ', ' . $uau['cuser'] . ', ' . $uau['cpass'] . (empty($uau['pm']) ? '' : ', ' . $uau['pm']) . '
					FROM `' . $uau['table'] . '`
					WHERE ' . $uau['cuser'] . ' = "' . $_REQUEST['username'] . '"', $auth) or die('5137 ' . mysql_error($auth));
			$r	= mysql_fetch_assoc($q);

			if($r[$uau['cpass']])
			{
				if(strcasecmp($r[$uau['cpass']], hash_wordpress($r[$uau['cpass']], $_REQUEST['password'])) === 0)
				{
					$_SESSION['playername']	= $_REQUEST['username'];
					$_SESSION['id']			= $r[$uau['id']];
					$_SESSION['pm']			= empty($r[$uau['pm']]) ? 0 : $r[$uau['pm']];
					$_SESSION['rememberMe']	= $_REQUEST['rememberMe'];
					@setcookie('Remember', $_REQUEST['rememberMe']);
				}
				else
				{
					$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
					$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
					$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
				}
			}
			else
			{
				$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
				$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
				$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
			}
		}
		elseif($uau['cms'] == 'xauth')
		{
			function hash_xauth($real, $post)
			{
				$cryptPass = false;
				$saltPos = (strlen($post) >= strlen($real) ? strlen($real) : strlen($post));
				$salt = substr($real, $saltPos, 12);
				$hash = hash('whirlpool', $salt . $post);
				$cryptPass = substr($hash, 0, $saltPos) . $salt . substr($hash, $saltPos);
				return $cryptPass;
			}

			$q	= mysql_query('
					SELECT ' . $uau['id'] . ', ' . $uau['cuser'] . ', ' . $uau['cpass'] . (empty($uau['pm']) ? '' : ', ' . $uau['pm']) . '
					FROM `' . $uau['table'] . '`
					WHERE ' . $uau['cuser'] . ' = "' . $_REQUEST['username'] . '"', $auth) or die('5137 ' . mysql_error($auth));
			$r	= mysql_fetch_assoc($q);

			if($r[$uau['cpass']])
			{
				$check = hash_xauth($r[$uau['cpass']], $_REQUEST['password']); 

				if(strcasecmp($r[$uau['cpass']], $check) === 0)
				{
					$_SESSION['playername']	= $_REQUEST['username'];
					$_SESSION['id']			= $r[$uau['id']];
					$_SESSION['pm']			= empty($r[$uau['pm']]) ? 0 : $r[$uau['pm']];
					$_SESSION['rememberMe']	= $_REQUEST['rememberMe'];
					@setcookie('Remember', $_REQUEST['rememberMe']);
				}
				else
				{
					$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
					$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
					$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
				}
			}
			else
			{
				$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
				$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
				$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
			}
		}
		elseif($uau['cms'] == 'cauth')
		{
			function hash_cauth($real, $post)
			{
				$crypt = false;
				if(strlen($real) < 32)
				{
					$crypt = md5($post);
					$rp = str_replace('0', '', $real);
					$cp = str_replace('0', '', $crypt);
					(strcasecmp($rp,$cp) == 0 ? $crypt = $real : $crypt = false);
				}
				else $crypt = md5($post);
				return $crypt;
			}

			$q	= mysql_query('
					SELECT ' . $uau['id'] . ', ' . $uau['cuser'] . ', ' . $uau['cpass'] . (empty($uau['pm']) ? '' : ', ' . $uau['pm']) . '
					FROM `' . $uau['table'] . '`
					WHERE ' . $uau['cuser'] . ' = "' . $_REQUEST['username'] . '"', $auth) or die('5137 ' . mysql_error($auth));
			$r	= mysql_fetch_assoc($q);

			if($r[$uau['cpass']])
			{
				$check = hash_cauth($r[$uau['cpass']], $_REQUEST['password']); 

				if(strcasecmp($r[$uau['cpass']], $check) === 0)
				{
					$_SESSION['playername']	= $_REQUEST['username'];
					$_SESSION['id']			= $r[$uau['id']];
					$_SESSION['pm']			= empty($r[$uau['pm']]) ? 0 : $r[$uau['pm']];
					$_SESSION['rememberMe']	= $_REQUEST['rememberMe'];
					@setcookie('Remember', $_REQUEST['rememberMe']);
				}
				else
				{
					$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
					$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
					$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
				}
			}
			else
			{
				$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
				$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
				$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
			}
		}
		elseif($uau['cms'] == 'drupal')
		{
			function hash_drupal($postPass, $realPass)
			{
				$cryptPass = false;
				$setting = substr($realPass, 0, 12);
				$itoa64 = './0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
				$count_log2 = strpos($itoa64, $setting[3]);
				$salt = substr($setting, 4, 8);
				$count = 1 << $count_log2;
				$input = hash('sha512', $salt . $postPass, TRUE);
				do $input = hash('sha512', $input . $postPass, TRUE);
				while (--$count);

				$count = strlen($input);
				$i = 0;
			  
				do
				{
					$value = ord($input[$i++]);
					$cryptPass .= $itoa64[$value & 0x3f];
					if ($i < $count) $value |= ord($input[$i]) << 8;
					$cryptPass .= $itoa64[($value >> 6) & 0x3f];
					if ($i++ >= $count) break;
					if ($i < $count) $value |= ord($input[$i]) << 16;
					$cryptPass .= $itoa64[($value >> 12) & 0x3f];
					if ($i++ >= $count) break;
					$cryptPass .= $itoa64[($value >> 18) & 0x3f];
				} while ($i < $count);
				$cryptPass =  $setting . $cryptPass;
				$cryptPass =  substr($cryptPass, 0, 55);
				return $cryptPass;
			}

			$q	= mysql_query('
					SELECT ' . $uau['id'] . ', ' . $uau['cuser'] . ', ' . $uau['cpass'] . (empty($uau['pm']) ? '' : ', ' . $uau['pm']) . '
					FROM `' . $uau['table'] . '`
					WHERE ' . $uau['cuser'] . ' = "' . $_REQUEST['username'] . '"', $auth) or die('5137 ' . mysql_error($auth));
			$r	= mysql_fetch_assoc($q);

			if($r[$uau['cpass']])
			{
				$checkPass = hash_drupal($r[$uau['cpass']], $_REQUEST['password']); 

				if(strcasecmp($r[$uau['cpass']], $checkPass) === 0)
				{
					$_SESSION['playername']	= $_REQUEST['username'];
					$_SESSION['id']			= $r[$uau['id']];
					$_SESSION['pm']			= empty($r[$uau['pm']]) ? 0 : $r[$uau['pm']];
					$_SESSION['rememberMe']	= $_REQUEST['rememberMe'];
					@setcookie('Remember', $_REQUEST['rememberMe']);
				}
				else
				{
					$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
					$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
					$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
				}
			}
			else
			{
				$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
				$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
				$err[] = '<p>' . $lang['ERROR_PASS'] . '<br /></p>';
			}
		}
		else
		{
			$q = mysql_query("
					SELECT ".$uau['id'].",".$uau['cuser'].",".$uau['cpass']."
					FROM ".$uau['table']."
					WHERE ".$uau['cuser']."='{$_REQUEST['username']}'
			", $auth) or die('Error MySQL query ' . mysql_error($auth));
			$r = mysql_fetch_assoc($q);

			if($r[$uau['cpass']])
			{
				$realPass = $r[$uau['cpass']];
				$postPass = $_REQUEST['password'];
				$checkPass = '';

				if (strlen($realPass) == 32)
				{
					$checkPass = md5($postPass);
				}
				else
				{
					if (strlen($realPass) <= 32)
					{
					$checkPass = substr(md5($postPass),-31);
					}
					else
					{

						if(strpos($realPass,'$SHA$') !== false)
						{
							$ar = preg_split("/\\$/",$realPass);
							$salt = $ar[2];
							$checkPass = '$SHA$'.$salt.'$'.hash('sha256',hash('sha256',$postPass).$salt);
						}
						else
						{
							$saltPos = (strlen($postPass) >= strlen($realPass) ? strlen($realPass) : strlen($postPass));
							$salt = substr($realPass, $saltPos, 12);
							$hash = hash('whirlpool', $salt . $postPass);
							$checkPass = substr($hash, 0, $saltPos) . $salt . substr($hash, $saltPos);
						}
					}
				}

				if(strcasecmp($realPass,$checkPass) == 0)
				{
					$_SESSION['playername']=$_REQUEST['username'];
					$_SESSION['id'] = $r[$uau['id']];
					$_SESSION['rememberMe'] = $_REQUEST['rememberMe'];
					@setcookie('Remember',$_REQUEST['rememberMe']);
				}
				else
				{
					$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
					$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
					$err[]=$lang['ERROR_PASSWORD'];
				}
			}
			else
			{
				$_SESSION['login_time']		= empty($_SESSION['login_time']) ? time() : $_SESSION['login_time'];
				$_SESSION['login_count']	= empty($_SESSION['login_count']) ? 1 : $_SESSION['login_count'] + 1;
				$err[]=$lang['ERROR_PASSWORD'];
			}
		}

		if(sizeof($err) > 0) header('Status: 401');
	}

	if($err) $_SESSION['msg']['login-err'] = implode('<br />',$err);

	if(!@$_SESSION['id'])
	{
		$info = '<p>'.$_SESSION['msg']['login-err'].'</p>' .
		'<form method="post" enctype="multipart/form-data">
		<table cellspacing="0" cellpadding="0">
		<tr>
		<td width="100">' . $lang['LOGIN'] . ':</td><td><input type="text" name="username" id="username" class="field" /></td>
		</tr><tr>
		<td>' . $lang['PASSWORD'] . ':</td><td><input type="password" name="password" id="password" class="field" /></td>
		</tr><tr>
		<td colspan="2" align="center"><a href="' . $mconf['reg'] . '" id="register_link">' . $lang['REGISTER'] . '</a> <input type="submit" name="submit" value="' . $lang['ENTER'] . '" class="button" /> <input name="rememberMe" id="rememberMe" type="checkbox"  value="1" /> &nbsp; ' . $lang['REMEMBER'] . '</td>
		</tr><tr>
		<td colspan="2" align="center"></td>
		</tr></table></form>';

		unset($_SESSION['msg']['login-err']);
	}
	else
	{
		$info = '<center>' . $lang['LOGIN_TRUE'] . '<br /><a href="?">' . $lang['BACK_ON_INDEX'] . '</a></center>';
		header('Location: ' . $mconf['fn']);
	}
	return '<div id="login">' . $info . '</div>';
}

function StrToInt($str)
{
	for($j=0, $i=0; $j <= strlen($str); $j++)
	{
		if(@$str[$j] >= '0' && @$str[$j] <= '9') $i .= $str[$j];
	}

	return (int) $i;
}

function GetUserListHTML($str)
{
	global $mconf, $server, $THEME, $lang;
	
	if(is_array($str)) $names = $str;
	else
	{
		$str = mb_substr($str,0,-1);
		$names = explode(', ',mb_substr($str, 19));
	}

	if(!empty($names))
	{
		for($i=0;$i<sizeof($names);$i++) trim($names[$i]);
	}

	if ($names['0']=='') unset($names);

	$a	= StrToInt($server[sizeof($server)-2]);
	$b	= StrToInt($server[sizeof($server)-1]);

	$server['4']	= 'monitor';
	$server['mon']	= (empty($b) || empty($a)) ? 200 : (200 - (200/100)*(($a / $b)*100));

	$users	= '';
	$html	= '
	<div class="menu-block"><div class="server-status">
		<h5><img src="' . $THEME . 'images/chart-bar_sticker.png" width="25" height="25" alt="" />' . $mconf['name'] . '</h5>
		<div class="' . $server['4'] . '" style="background-position:-' . $server['mon'] . 'px 0;">' . $a . '/' . $b . '</div>
		<p class="tiny-text">' . $lang['ADRESS'] . ': ' . $mconf['host'] . ':' . $mconf['port'] . '</p>
	';

	$names = empty($names) ? '' : $names;

	for($i=0; $i<sizeof($names); $i++)
	{
		if(empty($names[$i])) continue;

		$temp		= explode(":8:", $names[$i]);
		$names[$i]	= empty($temp['1']) ? $names[$i] : $temp['1'];

		$temp		= explode("§e", $names[$i]);
		$names[$i]	= empty($temp['1']) ? $names[$i] : $temp['1'];

		$temp		= explode("\n", $names[$i]);
		$names[$i]	= empty($temp['1']) ? $names[$i] : $temp['1'];

		if(empty($names[$i]) || strlen($names[$i]) > 30 || strpos($names[$i], ":") !== false)
		{
			unset($names[$i]);
			continue;
		}

		$users .= "
		<tr>
			<td class='ava'><a href='{$mconf['uprl']}{$names[$i]}'><img src='./upload/avatar.php?u={$names[$i]}' width='32px' height='32px' title='' alt='' style='margin:0;padding:0;' /></a></td>
			<td class='name'><a href='{$mconf['uprl']}{$names[$i]}'>{$names[$i]}</a></td>
		</tr>";
	}

	if (empty($names)) return $html . '</div></div>';

	return  $html . '<div class="cont2"><table width="100%" border="0" cellpadding="2px" cellspacing="2px">' . $users . '</table></div></div></div>';
}

class MinecraftRconException extends Exception
{
	//Exception thrown by MinecraftRcon class
}

class MinecraftRcon
{
	const SERVERDATA_EXECCOMMAND    = 2;
	const SERVERDATA_AUTH           = 3;

	const SERVERDATA_RESPONSE_VALUE = 0;
	const SERVERDATA_AUTH_RESPONSE  = 2;

	private $Socket;
	private $RequestId;

	public function __destruct()
	{
		$this->Disconnect();
	}

	public function Connect($Ip, $Port = 25565, $Password, $Timeout = 1)
	{
		$this->RequestId = 0;

		if( $this->Socket = @FSockOpen($Ip, (int)$Port, $errno, $errstr, $Timeout))
		{
			Socket_Set_TimeOut($this->Socket, 50000);

			if( !$this->Auth($Password))
			{
				$this->Disconnect();
				throw new MinecraftRconException("Authorization failed.");
			}
		}
	}

	public function Disconnect()
	{
		if($this->Socket)
		{
			FClose($this->Socket);
			$this->Socket = null;
		}
	}

	public function Command($String = '')
	{
		if($String != '')
		{
			if(!$this->WriteData(self :: SERVERDATA_EXECCOMMAND, $String))
			{
				return false;
			}
			
			$Data = $this->ReadData();
			
			if($Data['RequestId'] < 1 || $Data['Response'] != self :: SERVERDATA_RESPONSE_VALUE)
			{
				return false;
			}
			
			return $Data['String'];
		}
		else
		{
			global $mconf;

			if($mconf['type'] == 'spigot')
			{
				$socket = @socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
				$connected = @socket_connect($socket, $mconf['host'], $mconf['port']);
				 
				if(!$connected) return 'OFF:';
				 
				socket_send($socket, "\xFE\x01", 2, 0);
				$retVal = socket_recv($socket, $data, 1024, 0);
				socket_close($socket);
				 
				if ($retVal != false && substr($data, 0, 1) == "\xFF")
				{
					$data = substr($data, 9);
					$data = explode("\x00\x00", $data);
					$protocolVersion = $data[0];
					$serverVersion = $data[1];
					$motd = $data[2];
					$playersOnline = intval($data[3]);
					$playersMax = intval($data[4]);
					
					return $data;
				}
				else
				{
					return 'OFF:';
				}
			}
			else
			{
				$socket = @fsockopen($mconf['host'], $mconf['port'], $errno, $errstr, 1);
				@stream_set_timeout($this->Socket, 30, 0);

				if($socket !== false)
				{
					@fwrite($socket, "\xFE");
					$data = '';
					$data = @fread($socket, 1024);
					@fclose($socket);
					if ($data !== false && substr($data, 0, 1) == "\xFF")
					{
						$info = explode("\xA7", mb_convert_encoding(substr($data,1), 'iso-8859-1', 'utf-16be'));
						return $info;
					}
					else
					{
						return 'OFF:';
					}
				}
				else
				{
					return 'OFF:';
				}
			}
		}
	}
	
	private function Auth($Password)
	{
		if( !$this->WriteData(self :: SERVERDATA_AUTH, $Password))
		{
			return false;
		}
		
		$Data = $this->ReadData();
		
		return $Data['RequestId'] > -1 && $Data['Response'] == self :: SERVERDATA_AUTH_RESPONSE;
	}
	
	private function ReadData()
	{
		$Packet = Array();
		
		$Size = FRead($this->Socket, 4);
		$Size = UnPack('V1Size', $Size);
		$Size = $Size['Size'];

		$Packet = FRead($this->Socket, $Size);
		$Packet = UnPack('V1RequestId/V1Response/a*String/a*String2', $Packet);
		
		return $Packet;
	}
	
	private function WriteData($Command, $String = "")
	{
		$Data = Pack('VV', $this->RequestId++, $Command) . $String . "\x00\x00\x00"; 

		$Data = Pack('V', StrLen($Data)) . $Data;

		$Length = StrLen($Data);

		return $Length === @FWrite($this->Socket, $Data, $Length);
	}
}
?>
