<?php
/*
/	CMS Minecraft Shop   VPN.BY
/	  : http://forums.vpn.by/viewforum.vpn?f=212
/	  : http://mc.vpn.by/
/	v10.0.34 VGVMOTlSOG5sdC9RUDJKd3YyblpRRnhaQUFVZlEzYk9VSWJOd2kvVnBRQ1FpNUdQazc0RUxFbHVuaW55SllONVhFbVJBVDdF
*/

if(!defined('IN_VPN')) exit;

class RustQuery
{
	private $rSocket = false;
	private $aServer = array();

	public function __construct($host, $port = 0)
	{
		$this->aServer['0'] = $host;
		$this->aServer['1'] = $port;
		$this->rSocket = fsockopen('udp://'.$this->aServer['0'], $this->aServer['1'], $iError, $sError, 6);
		stream_set_timeout($this->rSocket, 6);
		stream_set_blocking($this->rSocket, TRUE);

		if(!$this->rSocket)
		{
			$this->aServer['4'] = false;
			return;
		}

		$sPacket = "\xFF\xFF\xFF\xFF\x54Source Engine Query\x00";

		fwrite($this->rSocket, $sPacket);

		if($this->aServer['response'] = fread($this->rSocket, 4096))
		{
			$this->aServer['4'] = true;
			return;
		}

		$this->aServer['4'] = false;
	}

	public function __destruct()
	{
		@fclose($this->rSocket);
	}

	public function isOnline()
	{
		return isset($this->aServer['4']) ? $this->aServer['4'] : false;
	}

	public function GetInfo()
	{
		if(empty($this->aServer['4'])) return false;

		$p = explode("\x00", substr($this->aServer['response'], 6), 5);

		$e['host']			= $this->aServer['0'];
		$e['port']			= $this->aServer['1'];
		$e['name']			= $p['0'];
		$e['map']			= $p['1'];
		$e['Software']		= $p['2'];
		$e['description']	= $p['3'];
		$i					= $p['4'];
		$e['Players']		= ord(substr($i, 2, 1));
		$e['MaxPlayers']	= ord(substr($i, 3, 1));
		$e['password']		= ord(substr($i, 7, 1));
		$e['vac']			= ord(substr($i, 8, 1));

		return $e;
	}
}
