<?php
/*
/	CMS Minecraft Shop © ltd VPN BY
/	Форум технической поддержки: http://forums.vpn.by/viewforum.vpn?f=212
/	Адрес информационного сайта: http://cmsminecraftshop.com/
/
*/

if(!defined('IN_VPN')) exit;

function smtpmail($mail_to, $sbj, $message, $headers = '')
{
	global $config;

	if(empty($config['smtp_host']) || (empty($config['smtp_user']) && empty($config['smtp_pass'])))
	{
		mail($mail_to, $sbj, $message, $headers='');
		return TRUE;
	}

	$MAIL  =   'Date: ' . date('D, d M Y H:i:s') . " UT\r\n";
	$MAIL .=   'Subject: ' . $sbj . "\r\n";
	if($headers)
	{
		$MAIL .= $headers . "\r\n\r\n";
	}
	else
	{
		$MAIL .= 'Reply-To: ' . $config['smtp_user'] . "\r\n";
		$MAIL .= 'MIME-Version: 1.0' . "\r\n";
		$MAIL .= 'Content-Type: text/plain; charset="' . $config['smtp_charset'] . "\"\r\n";
		$MAIL .= 'Content-Transfer-Encoding: 8bit' . "\r\n";
		$MAIL .= 'From: "' . $config['smtp_from'] . '" <' . $config['smtp_user'] . ">\r\n";
		$MAIL .= 'To: ' . $mail_to . ' <' . $mail_to . ">\r\n";
		$MAIL .= 'X-Priority: 3' . "\r\n\r\n";
	}
	$MAIL .=  $message . "\r\n";
	if(!$socket = fsockopen($config['smtp_host'], $config['smtp_port'], $errno, $errstr, 30))
	{
		if($config['smtp_debug']) echo $errno . '&lt;br&gt;' . $errstr;
		return false;
	}

	if(!server_parse($socket, '220', __LINE__)) return false;

	fputs($socket, 'HELO ' . $config['smtp_host'] . "\r\n");
	if(!server_parse($socket, '250', __LINE__))
	{
		if($config['smtp_debug']) echo '<p>Error send HELO!</p>';
		fclose($socket);
		return false;
	}

	fputs($socket, 'AUTH LOGIN' . "\r\n");
	if(!server_parse($socket, '334', __LINE__))
	{
		if($config['smtp_debug']) echo '<p>No response to the authorization request.</p>';
		fclose($socket);
		return false;
	}
	fputs($socket, base64_encode($config['smtp_user']) . "\r\n");
	if(!server_parse($socket, '334', __LINE__))
	{
		if($config['smtp_debug']) echo '<p>Login authorization was not accepted by the server.</p>';
		fclose($socket);
		return false;
	}
	fputs($socket, base64_encode($config['smtp_pass']) . "\r\n");
	if(!server_parse($socket, '235', __LINE__))
	{
		if($config['smtp_debug']) echo '<p>Error! Password is not accepted by the server as a faithful.</p>';
		fclose($socket);
		return false;
	}
	fputs($socket, 'MAIL FROM: <' . $config['smtp_user'] . ">\r\n");
	if(!server_parse($socket, '250', __LINE__))
	{
		if($config['smtp_debug']) echo '<p>I can not send command MAIL FROM: </p>';
		fclose($socket);
		return false;
	}
	fputs($socket, 'RCPT TO: <' . $mail_to . ">\r\n");

	if(!server_parse($socket, '250', __LINE__))
	{
		if($config['smtp_debug']) echo '<p>I can not send command RCPT TO: </p>';
		fclose($socket);
		return false;
	}
	fputs($socket, 'DATA' . "\r\n");

	if(!server_parse($socket, '354', __LINE__))
	{
		if($config['smtp_debug']) echo '<p>I can not send command DATA</p>';
		fclose($socket);
		return false;
	}
	fputs($socket, $MAIL . "\r\n.\r\n");

	if(!server_parse($socket, '250', __LINE__))
	{
		if($config['smtp_debug']) echo '<p>Could not send the message body. Letter not been sent!</p>';
		fclose($socket);
		return false;
	}
	fputs($socket, "QUIT\r\n");
	fclose($socket);
	return TRUE;
}

function server_parse($socket, $response, $line = __LINE__)
{
	global $config;

	$resp = '';

	while(substr($resp, 3, 1) != ' ')
	{
		if(!($resp = fgets($socket, 256)))
		{
			if($config['smtp_debug']) echo '<p>Problems sending mail.</p>' . $response . '<br>' . $line . '<br>';
			return false;
		}
	}
	if(!(substr($resp, 0, 3) == $response))
	{
		if($config['smtp_debug']) echo '<p>Problems sending mail.</p>' . $response . '<br>' . $line . '<br>';
		return false;
	}
	return true;
}

?>
