<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title><?=$title?></title>
<meta name="generator" content="CMS Minecraft Shop v<?=MS_VERSION?>">
<link rel="shortcut icon" type="image/x-icon" href="<?=$THEME?>images/favicon.ico" />
<link rel="icon" type="image/gif" href="<?=$THEME?>images/favicon-32x32.gif?132" />
<LINK rel="stylesheet" media="screen" type="text/css" title="Style" href="<?=$THEME?>css/style.css?4">
<LINK rel="stylesheet" media="screen" type="text/css" title="Style" href="<?=$THEME?>css/menu.css?7">
<LINK rel="stylesheet" media="screen" type="text/css" title="Style" href="<?=$THEME?>css/shop.css?4">
<script type="text/javascript" src="<?=$THEME?>js/jquery.js"></script>
<script src="<?=$THEME?>js/jquery.min.js"></script>
<script src="<?=$THEME?>js/jquery-ui.min.js"></script>
<script type="text/javascript" src="<?=$THEME?>js/menu.js"></script><?=$css?>
</head>
<body>
<div class="header">
	<div class="header-left">
		<div id="header-img">
			<a href="./" title="<?=$title?>"><img src="<?=$img?>" height="80"/></a>
			<div id="header-option"> <a href="<?=$launcher?>"><?=$lang['DOWNLOAD']?></a> &nbsp; &nbsp;
				<a href="<?=$mconf['fn']?>?page=lang&amp;set=ru" hreflang="ru"><img src="<?=$THEME?>images/language/Russian.gif" alt="ru" /></a>
				<a href="<?=$mconf['fn']?>?page=lang&amp;set=en" hreflang="en"><img src="<?=$THEME?>images/language/English.gif" alt="en" /></a>
			</div>
		</div>
	</div>
</div>
<hr style="border-top:1px solid #fff;border-bottom:1px solid #777;" />

<?=$menu?>

<hr />
<div class="bottom-shadow"></div>
<div class="content">
	<div class="left-block">
		<div id="userroom" style="min-height:350px;">
			<div class="profile-block">
				<?=$content?>
			</div>		
		</div>
	</div>
	<div class="right-block">
		<?=$monitoring?>
	</div>
</div>

<div class="shadow-top"></div>
<hr style="border:none;margin:0;padding:0;background:#000000;border-top:1px solid #ffffff;border-bottom:1px solid #ffffff;" />
<div class="footer">
	<div class="footer-center">
		<a href="http://cmsminecraftshop.com/" target="_blank"><img src="<?=$THEME?>images/88x31-b.png" alt="CMS Minecraft Shop"></a>
		<a href="http://www.megastock.ru/" target="_blank"><img src="<?=$THEME?>images/acc_blue_on_white_ru.png" alt="Megastock"></a>
		<div class="footer-right">
			<?=$copy?>
		</div>
	</div>
</div>
<script type="text/javascript">
$(function(){
	var $menu = $("#menu");
	$(window).scroll(function(){
		if ($(this).scrollTop() > 120 && $menu.hasClass("default") ){
			$menu.fadeOut('fast',function(){
				$(this).removeClass("default")
					   .addClass("fixed")
					   .fadeIn('fast');
			});
		} else if($(this).scrollTop() <= 120 && $menu.hasClass("fixed")){
			$menu.fadeOut('fast',function(){
				$(this).removeClass("fixed")
					   .addClass("default")
					   .fadeIn('fast');
			});
		}
	});
});
</script>
<!-- Yandex.Metrika counter -- > <script type="text/javascript"> (function (d, w, c) { (w[c] = w[c] || []).push(function() { try { w.yaCounter26121861 = new Ya.Metrika2({ id:26121861, clickmap:true, trackLinks:true, accurateTrackBounce:true, webvisor:true, trackHash:true }); } catch(e) { } }); var n = d.getElementsByTagName("script")[0], s = d.createElement("script"), f = function () { n.parentNode.insertBefore(s, n); }; s.type = "text/javascript"; s.async = true; s.src = "https://mc.yandex.ru/metrika/tag.js"; if (w.opera == "[object Opera]") { d.addEventListener("DOMContentLoaded", f, false); } else { f(); } })(document, window, "yandex_metrika_callbacks2"); </script> <noscript><div><img src="https://mc.yandex.ru/watch/26121861" style="position:absolute; left:-9999px;" alt="" /></div></noscript> <!-- /Yandex.Metrika counter -->
</body>
</html>