<?php
/*
/	CMS Minecraft Shop © ltd VPN BY
/	Форум технической поддержки: http://forums.vpn.by/viewforum.vpn?f=212
/	Адрес информационного сайта: http://cmsminecraftshop.com/
*/

error_reporting(E_ALL);
define('IN_VPN', true);
require_once('../config.php');
require_once('../includes/constants.php');
header('X-Powered-By: CMS Minecraft Shop v' . MS_VERSION);

if(version_compare(phpversion(), '7.0', '>'))
{
	require_once('../includes/db.mysql.php');
}

mysql_connect($hostname, $bd_user, $bd_password) or die('Error 258467 ' . mysql_error());
mysql_select_db($database) or die(mysql_error());
//mysql_query('SET NAMES utf8');

$path = mysql_query('SELECT `value` FROM `' . SETTINGS . '` WHERE `name` = "skins_path"') or die(mysql_error());
$path = mysql_result($path, 0) or die('976 ' . mysql_error());
$path = $path . str_replace(array('.', '/', '\'', '"', '`'), '', @$_GET['skinpath']) . '.png';
$scalee = 6;

if(!file_exists($path))
{
	$path = './skins/char.png';
	$test = new Skin2d();
	$test->AssignSkinFromFile($path);
}
else
{
	$test = new Skin2d();
	$test->AssignSkinFromFile($path);
}

header("Content-Type: image/png");

$img			= $test->CombinedImage($scalee);
$transparent	= imagecolorallocatealpha($img, 0, 0, 0, 127);

imagefill($img, 0, 0, $transparent);

$transparent2	= imagecolorallocatealpha($img, 0, 0, 0, 127);
imagefill($img, 12*$scalee, 0, $transparent2);

$transparent3	= imagecolorallocatealpha($img, 0, 0, 0, 127);
imagefill($img, 0, 21*$scalee, $transparent3);

imagesavealpha($img, true);
imagepng($img);

class Skin2d
{
    private $image = NULL;

    function __destructor()
	{
        if ($this->image != NULL) {
            imagedestroy($this->image);
        }
    }

    function AssignSkinFromFile ($file)
	{
        if($this->image != NULL)
		{
            imagedestroy($this->image);
        }
        if(($this->image = imagecreatefrompng($file)) == False)
		{

            throw new Exception("Could not open PNG file.");
        }
        if(!$this->Valid())
		{
            throw new Exception("Invalid skin image.");
        }
    }

    function AssignSkinFromString ($data)
	{
        if($this->image != NULL)
		{
            imagedestroy($this->image);
        }
        if(($this->image = imagecreatefromstring($data)) == False)
		{
            throw new Exception("Could not load image data from string.");
        }
        if(!$this->Valid())
		{
            throw new Exception("Invalid skin image.");
        }
    }

    function Width()
	{
        if($this->image != NULL)
		{
            return imagesx($this->image);
        }
		else
		{
            throw new Exception("No skin loaded.");
        }
    }

    function Height()
	{
        if($this->image != NULL)
		{
            return imagesy($this->image);
        }
		else
		{
            throw new Exception("No skin loaded.");
        }
    }

    function Valid()
	{
        return ($this->Width() != 64 || $this->Height() != 32) ? False : True;
    }

    function CombinedImage ($scale = 1)
	{
        $newWidth = 16 * $scale;
        $newHeight = 32 * $scale;
		$newImage = imagecreatetruecolor(16, 32);
		$transparent4 = imagecolorallocatealpha($newImage, 0, 0, 0, 127);
		imagefill($newImage, 0, 0, $transparent4);
        imagecopy($newImage, $this->image, 4, 0, 8, 8, 8, 8);
        $this->imagecopyalpha($newImage, $this->image, 4, 0, 40, 8, 8, 8, imagecolorat($this->image, 63, 0));
        imagecopy($newImage, $this->image, 4, 8, 20, 20, 8, 12);
        imagecopy($newImage, $this->image, 8, 20, 4, 20, 4, 12);
        imagecopy($newImage, $this->image, 4, 20, 4, 20, 4, 12);
        imagecopy($newImage, $this->image, 12, 8, 44, 20, 4, 12);
        imagecopy($newImage, $this->image, 0, 8, 44, 20, 4, 12);

        if($scale != 1)
		{
            $resize = imagecreatetruecolor($newWidth, $newHeight);
            imagecopyresized($resize, $newImage, 0, 0, 0, 0, $newWidth, $newHeight, 16, 32);
            imagedestroy($newImage);
            return $resize;
        }
         return $newImage;
    }

    function imagecopyalpha($dst, $src, $dst_x, $dst_y, $src_x, $src_y, $w, $h, $bg)
	{
        for($i = 0; $i < $w; $i++)
		{
            for($j = 0; $j < $h; $j++)
			{
				$rgb = imagecolorat($src, $src_x + $i, $src_y + $j);
				if(($rgb & 0xFFFFFF) == ($bg & 0xFFFFFF))
				{
                    $alpha = 127;
                }
				else
				{
					$colors = imagecolorsforindex($src, $rgb);
					$alpha = $colors["alpha"];
                }
                imagecopymerge($dst, $src, $dst_x + $i, $dst_y + $j, $src_x + $i, $src_y + $j, 1, 1, 100 - (($alpha / 127) * 100));
            }
        }
	}
}
